/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 03 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

int main(void) {
  int n, tmp, bit, oct, hex;
  char c[] = {'A', 'B', 'C', 'D', 'E', 'F'};

  /* read number */
  do {
    printf("Decimal number (>=0): ");
    scanf("%d", &n);
    if (n < 0) {
      printf("Negative value, re-read!\n");
    } 
  } while (n < 0);

  /* compute the binary number (from LSB) */
  tmp = n;
  printf("Binary number (from LSB) = ");
  do {
    bit = tmp % 2;
    printf("%d", bit);
    tmp = tmp / 2;
  } while (tmp != 0);
  printf("\n");

  /* compute the octal number (from LSD) */
  tmp = n;
  printf("Octal number (from LSD) = ");
  do {
    oct = tmp % 8;
    printf("%d", oct);
    tmp = tmp / 8;
  } while (tmp != 0);
  printf("\n");

  /* compute the hexadecimal number (from LSD) */
  tmp = n;
  printf("Hexadecimal number (from LSD) = ");
  do {
    hex = tmp % 16;
    if (hex>=10) {
      printf("%c", c[hex-10]);
    } else {
      printf("%d", hex);
    }
    tmp = tmp / 16;
  } while (tmp != 0);
  printf("\n");

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
