/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 03 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>

/* Max number of digits in b=2, 8, 16 */
#define N_B 64
#define N_O 22
#define N_H 16

int main(void) {
  int n, nb, no, nh, i, j, p;
  int bit[N_B], oct[N_O], hex[N_H];
  char c[] = {'A', 'B', 'C', 'D', 'E', 'F'};

  /* read number */
  do {
    printf("Decimal number (>=0): ");
    scanf("%d", &n);
    if (n < 0) {
      printf("Negative value, re-read!\n");
    } 
  } while (n < 0);

  /* compute the binary number (from MSB) */
  printf("Binary number (from MSB) = ");
  nb = 0;
  do {
    bit[nb] = n % 2;
    n = n / 2;
    nb++;
  } while (n != 0);
  for (i=nb-1; i>=0; i--) {
    fprintf(stdout, "%d", bit[i]);
  }
  fprintf(stdout, "\n");

  /* compute the octal number (from MSD) */
  printf("Octal number (from MSB) = ");
  for (no=0, i=0; i<nb; no++, i+=3) {
    oct[no] = 0;
    for (p=1, j=i; j<i+3 && j<nb; j++, p*=2) {
      oct[no] = oct[no] + bit[j] * p;
    } 
  }
  for (i=no-1; i>=0; i--) {
    fprintf(stdout, "%d", oct[i]);
  }
  fprintf(stdout, "\n");

  /* compute the hexadecimal number (from MSD) */
  printf("Hexadecimal number (from MSD) = ");
  for (nh=0, i=0; i<nb; nh++, i+=4) {
    hex[nh] = 0;
    for (p=1, j=i; j<i+4 && j<nb; j++, p*=2) {
      hex[nh] = hex[nh] + bit[j] * p;
    } 
  }
  for (i=nh-1; i>=0; i--) {
    if (hex[i]>=10) {
      printf("%c", c[hex[i]-10]);
    } else {
      printf("%d", hex[i]);
    }
  }
  fprintf(stdout, "\n");

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
