/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 08 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define MAX_LEN 31

int main(int argc, char *argv[]) {
  char s1[MAX_LEN], s2[MAX_LEN];
  int occurrences[26], i, flag;

  /* manage parameters */ 
  if (argc != 3) {
    printf("Parameter error.\n");
    printf("Run program as: %s <string1> <string2>\n", argv[0]);
    return 1;
  }
  strcpy(s1, argv[1]);
  strcpy(s2, argv[2]);

  /* check for anagrams */
  for (i=0; i<26; i++) {
    occurrences[i] = 0;
  }
  for (i=0; i<strlen(s1); i++) {
    occurrences[tolower(s1[i]) - 'a']++;
  }
  for (i=0; i<strlen(s2); i++) {
    occurrences[tolower(s2[i]) - 'a']--;
  }
  flag = 1;
  for (i=0; i<26 && flag; i++) {
    if (occurrences[i] != 0) {
      flag = 0;
    }
  }

  /* output result */
  if (flag) {
    printf("The two words are anagrams.\n");
  } else {
    printf("The two words are NOT anagrams.\n");
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
