/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 13 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define DIM 50

int main (int argc, char *argv[]) {
  char str1[DIM+1], str2[DIM+1], str3[DIM+1];
  char strOut[DIM*DIM+1], *start, *end;

  /* check parameters */
  if (argc != 4) {
    printf("Parameter error.\n");
    printf("Run program as: %s <string1> <string2> <string3>\n", argv[0]);
    return 1;
  }

  strcpy(str1, argv[1]);
  strcpy(str2, argv[2]);
  strcpy(str3, argv[3]);

  /* computation and output */
  strOut[0] = '\0';
  start = str1;
  do {
    end = strstr(start, str2);
    if (end == NULL) {
      strcat(strOut, start);
    } else {
      strncat(strOut, start, end-start);
      strcat(strOut, str3);
      start = end + strlen(str2);
    }
  } while (end != NULL);

  printf("%s\n", strOut);

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
