/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 01 - exercise 14 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

#define MAX   3
#define TRUE  1
#define FALSE 0

/* function prototypes */
float average(float matrixIn[MAX][MAX], int x, int y);
int valid(int x, int y);

/*
 *  main program
 */
int main(void) {
  float matrixIn[MAX][MAX], matrixAvg[MAX][MAX];
  int x, y;

  /* read in the input matrix */
  printf("Input matrix:\n");
  for (x=0; x<MAX; x++) {
    for (y=0; y<MAX; y++) {
      printf("Element [%d][%d] = ", x, y);
      scanf("%f", &matrixIn[x][y]);
    }
  }

  /* compute the output matrix */
  for (x=0; x<MAX; x++) {
    for (y=0; y<MAX; y++) {
      matrixAvg[x][y] = average(matrixIn, x, y);
    }
  }

  /* print out result */
  printf("Output matrix:\n");
  for (x=0; x<MAX; x++) {
    for (y=0; y<MAX; y++) {
      printf("%6.2f", matrixAvg[x][y]);
    }
    printf ("\n");
  }

  return 0;
}

/* 
 *  compute the average of adjacent elements
 */
float average (float matrixIn[MAX][MAX], int x, int y) {
  int i, j, count;
  float sum;

  sum = count = 0;
  for (i=-1; i<=1; i++) {
    for (j=-1; j<=1; j++) {
      if ((i!=0 || j!=0) && valid(x+i, y+j)==TRUE) {
        count++;
        sum += matrixIn[x+i][y+j];
      }
    }
  }
  return sum/count;
}

/* 
 *  check whether the element [x][y] is inside (belongs to) the matrix
 */
int valid (int x, int y) {
  if (x<0 || x>=MAX) {
     return FALSE;
  }
  if (y<0 || y>=MAX) {
     return FALSE;
  }

  return TRUE;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
