/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 03 - exercise 01 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MAX_ID   3+1
#define MAX_NAME 10+1

/* structure declaration */
typedef struct {
  float x;
  float y;
  float z;
  float dist;
} point_t;

int main (void) {
  char name[MAX_NAME];
  int n, i, j, min=0;
  float dx, dy, dz;
  point_t *points;
  FILE *fp;

  /* load the input file */
  fprintf(stdout, "Input file name: ");
  scanf("%s", name);
  fp = fopen(name, "r");
  if (fp == NULL) {
    fprintf(stderr,"File open error (file=%s).\n", name);
    exit(EXIT_FAILURE);
  }

  if (fscanf(fp, "%d", &n)==EOF || n<=0) {
    fprintf(stderr, "Read file error (file=%s).\n", name);
    return EXIT_FAILURE;
  }
  points = (point_t *)malloc(n * sizeof(point_t));
  if (points == NULL) {
    fprintf(stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }

  i = 0;
  while (i<n && fscanf(fp, "%f%f%f", &dx, &dy, &dz)!=EOF) {
    points[i].x = dx;
    points[i].y = dy;
    points[i].z = dz;
    points[i].dist = 0;
    i++;
  }
  n = i;

  /* find and print the median point */
  min = 0;
  for (i=0; i<n; i++) {
    for (j=0; j<n; j++) {
      dx = points[i].x - points[j].x;
      dy = points[i].y - points[j].y;
      dz = points[i].z - points[j].z;
      points[i].dist += sqrt(pow(dx, 2) + pow(dy, 2) + pow(dz, 2));
    }
    if (points[i].dist < points[min].dist) {
      min = i;
    }
  }
  fprintf(stdout, "Median point: %.2f ", points[min].x);
  fprintf(stdout, "%.2f %.2f\n", points[min].y, points[min].z);

  free(points);

  return EXIT_SUCCESS;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
