/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 05 - exercise 05 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#define N 10

typedef struct element_s {
  int key;
  struct element_s *next;
} element_t;

/* function prototypes */
void list_r_ver1 (element_t *);
void list_r_ver2 (element_t *);

/*
 *  main program
 */
int main (void) {
  int i;
  int v[N] = {1, 3, 5, 7, 9, 11, 8, 6, 4, 2};
  element_t *p, *head;
  
  /* list creation (push element into the lsit) */
  head = NULL;
  for (i=0; i<N; i++) {
    p = malloc (1 * sizeof (element_t));
    if (p == NULL) {
      fprintf (stderr, "Memory allocation error.\n");
      exit(EXIT_FAILURE);
    }
    p->key = v[i];
    p->next = head;
    head = p;
  }

  fprintf(stdout, "List: ");
  list_r_ver1 (head);
  fprintf(stdout, "\n");

  fprintf(stdout, "List: ");
  list_r_ver2 (head);
  fprintf(stdout, "\n");

  return EXIT_SUCCESS;
}

/*
 *  list visit from head to tail
 */
void list_r_ver1 (element_t *head) {
  if (head == NULL) {
    return;
  }

  fprintf (stdout, "%d ", head->key);
  list_r_ver1 (head->next);

  return;
}

/*
 *  list visit from head to tail
 */
void list_r_ver2 (element_t *head) {
  if (head == NULL) {
    return;
  }

  list_r_ver2 (head->next);
  fprintf (stdout, "%d ", head->key);

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
