/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 05 - exercise 06 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

/* function prototypes */
int gcd_i (int, int);
int gcd_r (int, int);

/*
 *  main program
 */
int main (void) {
  int x, y, vr, vi;

  fprintf(stdout, "First number: ");
  scanf("%d", &x);
  fprintf(stdout, "Second number: ");
  scanf("%d", &y);

  if (x > y) {
    vr = gcd_r(x, y);
    vi = gcd_i(x, y);
  } else {
    vr = gcd_r(y, x);
    vi = gcd_i(y, x);
  }
  fprintf(stdout, "GCD(%d, %d): Rec=%d; Ite=%d\n", x, y, vr, vi);

  return EXIT_SUCCESS;
}

/*
 *  GCD computation, recursive function
 */
int gcd_r (int M, int m) {
  if (m == 0) {
    return M;
  }

  return gcd_r(m, M%m);
}
#include <stdio.h>

/*
 *  GCD computation, iterative function
 */
int gcd_i (int M, int m) {
  int r;

  while ( m!=0 ) {
    r = M%m;
    M = m;
    m = r;
  }

  return M;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
