/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 06 - exercise 04 - solution 0
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>

/* function prototypes */
int combination_repetition(int *, int *, int, int, int, int, int);

/*
 *  main program
 */
int main(int argc, char *argv[]) {
  const int n = 3;
  const int k = 2;
  int value[] = {1, 2, 3};
  int solution[] = {0, 0};
  int pos = 0;
  int start = 0;
  int count = 0;
  int total;

  fprintf(stdout, "Combinations with repetitions:\n");
  total = combination_repetition (value, solution, n, k, start, pos, count);
  fprintf(stdout, "\nTotal Number: %d\n", total);

  return EXIT_SUCCESS;
}

/*
 *  Combinations with Repetitions
 */
int combination_repetition(
  int *value, int *solution, int n, int m, int start, int pos, int count
  )
{
  int i;

  if (pos >= m) {
    fprintf(stdout, "{ ");
    for (i=0; i<m; i++) {
      fprintf(stdout, "%d ", solution[i]);
    }
    fprintf(stdout, "}");
    return count+1;
  }

  for (i=start; i<n; i++) {
    solution[pos] = value[i];
    count = combination_repetition(value, solution, n, m, i, pos+1, count);
  }

  return count;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
