/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 06 - exercise 07 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX 10

/* function prototypes */
void generate_r (char *, char *, int *, int, int);

/*
 *  main program
 */
int main (void) {
  char word[MAX], anagram[MAX];;
  int used[MAX];
  int length, i;

  fprintf(stdout, "Input a word: ");
  scanf("%s", word);
  length = strlen(word);
  anagram[length] = '\0';
  for (i=0; i<length; i++) {
    used[i] = 0;
  }

  fprintf(stdout, "Anagrams:\n");
  generate_r(word, anagram, used, length, 0);
  return EXIT_SUCCESS;
}

/*
 *  add a char in position n of the anagram taking it from 
 *  the (unused) available chars in the word
 */
void generate_r (char *word, char *anagram, int *used, int length, int n) {
  int i;

  if (n == length) {
    fprintf(stdout, "  %s\n", anagram);
    return;
  }

  for (i=0; i<length; i++) {
    if (used[i] == 0) {
      used[i] = 1;
      anagram[n] = word[i];
      generate_r (word, anagram, used, length, n+1);
      used[i] = 0;
    }
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
