/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 09 - exercise 03 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <ctype.h>
#include "queuePublic.h"
#include "item.h"

#define SIZE 50
#define MAX  20

int main (void) {
  char command[MAX];
  queue_t *qp=NULL;
  item_t data;
  int stop=0;

  do {
    fprintf(stdout, "\nAvailable commands:\n");
    fprintf(stdout, "  (N)ew\n  (I)nsert\n");
    fprintf(stdout, "  (E)xtract\n  (D)isplay\n");
    fprintf(stdout, "  (S)top\nChoice: ");
    scanf("%s", command);

    switch (tolower(command[0])) {
      case 'n':
        queue_dispose(qp, item_dispose);
        qp = queue_init(SIZE);
        fprintf(stdout, "New queue correctly created.\n");
        break;
      case 'i':
        fprintf(stdout, "Input data: ");
        item_read(stdin, (void **)&data);
        if (!queue_put(qp, (void *)data)) {
          fprintf(stdout, "Error in put!\n");
        } else {
          fprintf(stdout, "Data correctly inserted.\n");
        }
        break;
      case 'e':
        if (!queue_get(qp, (void **)&data)) {
          fprintf(stdout, "Error in get!\n");
        } else {
          fprintf(stdout, "Extracted data: ");
          item_print(stdout, (void *)data);
          fprintf(stdout, "\n");
        }
        break;
      case 'd':
        queue_print(stdout, qp, item_print);
        break;
      case 's':
        stop = 1;
        break;
      default:
        fprintf(stderr, "Unknown command!\n");
    }
  } while (!stop);

  queue_dispose(qp, item_dispose);

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
