/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 09 - exercise 04 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#ifndef _LIST
#define _LIST

#include <stdio.h>

/* macro definition */
#define list_empty_m(lp) (lp == NULL)

/* type declaration */
typedef struct list_s list_t;

/* extern function prototypes */
extern list_t *list_init(void);
extern int list_count(list_t *lp);
extern int list_search(list_t *lp, void *key, float (*compare)(void *, void *), 
                       void **data_ptr);
extern list_t *list_add(list_t *lp, void *data, int pos);
extern list_t *list_insert(list_t *lp, void *data, float (*compare)(void *, void *));
extern list_t *list_extract(list_t *lp, void *key, float (*compare)(void *, void *), 
                            void **data_ptr);
extern void list_print(FILE *fp, list_t *lp, void (*print)(FILE *, void *));
extern void list_dispose(list_t *lp, void (*quit)(void *));

#endif

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
