/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 09 - exercise 05 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include "util.h"
#include "date.h"

int main (void) {
  date_t prev, next, curr, diff;
  FILE *fp;
  
  fp = util_fopen("dates.txt", "r");
  date_read(fp, &curr);
  prev = next = curr;
  while (date_read(fp, &curr) != EOF) {
    if (date_compare(prev, curr) > 0) {
      prev = curr;
    }
    if (date_compare(next, curr) < 0) {
      next = curr;
    }
  }
  fclose(fp);
  
  fprintf(stdout, "Oldest date: ");
  date_print(stdout, prev);
  fprintf(stdout, "Newest date: ");
  date_print(stdout, next);

  diff = date_difference(prev, next);
  fprintf(stdout, "Total time spent: ");
  date_print(stdout, diff);

  return EXIT_SUCCESS;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
