/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 * chapter 09 - exercise 06 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdio.h>
#include <math.h>
#include "point.h"

/*
 *  read a point from file
 */
int point_read (FILE *fp, point_t *pp) {
  int result = fscanf(fp, "%f %f", &pp->x, &pp->y);

  if (result != EOF) {
    pp->d = sqrt(pp->x*pp->x + pp->y*pp->y);
  }
  return result;
}

/*
 *  print a point on file
 */
void point_print (FILE *fp, point_t p) {
  fprintf(fp, "%+.2f %+.2f\n", p.x, p.y);
}

/*
 *  return the distance of a point from the origin
 */
float distance1 (point_t p) {
  return p.d;
}

/*
 *  return the distance between two points
 */
float distance2 (point_t p1, point_t p2) {
  float dx, dy;

  dx = p2.x - p1.x;
  dy = p2.y - p1.y;

  return sqrt(dx*dx + dy*dy);
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part II: Algorithms and Data Structures
 *
 */
